/* 26may03 */
//***************************************************************************
// Trying to put the OLD space into M/S syzygy.
//***************************************************************************

/* CAVEFar = - CAVENear is necessary for the spherical case to be correct */ 
/* However, the stuff between z = -CAVENear and + CAVENear is invisible */
/* the siz-ing is in the wrong place and wrong magnitude, but works ??? */
/* and the console mode works like a charm */
/* illiOpenSkelShpace */
/* with slevyfrustum */
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#ifdef UNIX
#include <sys/time.h>
#endif
#include <GL/glut.h>
/*%%%%%%%%%%%%%%%%%%%%%%%CAVEish%%%%%%%%%%%%%%%%*/
#include <malloc.h>     /* for the shared vars */

#ifdef CAVE
#include <cave_ogl.h>
#include <cave.macros.h>
#endif  /* CAVE */

/*%%%%%%%%%%%%%%%%%%%%%end CAVEish%%%%%%%%%%%%%%%%*/

//---------------------SYZYGIZED------------------
#ifdef SYZYGY
#include "arMasterSlaveFramework.h"
#endif
//------------------------------------------------

#define  MAX(x,y)  ((x<y)?y:x)
#define  MIN(x,y)  ((x<y)?x:y)
#define  ABS(x)    ((x<0)?-x:x)
#define  FOR(a,b,c) for(a=b;a<c;a++) 
#define  EDOT(p,q)  ((p)[0]*(q)[0]+(p)[1]*(q)[1]+(p)[2]*(q)[2])
#define  ENORM(p)   sqrt(EDOT(p,p))
#define  SDOT(p,q)  ((p)[0]*(q)[0]+(p)[1]*(q)[1]+(p)[2]*(q)[2]+(p)[3]*(q)[3])
#define  SNORM(p)   sqrt(SDOT(p,p))
#define  HDOT(p,q)  ((p)[0]*(q)[0]+(p)[1]*(q)[1]+(p)[2]*(q)[2]-(p)[3]*(q)[3])
#define  HNORM(p)    sqrt(fabsf(HDOT(p,p))) /* We cheat a little here ... */
#define  SIZE        1  /* 1 appears to be necessary was originally 100 */
#define LEVELS       5
#define HYPERBOLIC (curv == -1)
#define SPHERICAL  (curv ==  1)

/* Possibly useful geometric macros from illiOpenSkel */
#define  DOT(p,q)         ((p)[0]*(q)[0]+(p)[1]*(q)[1]+(p)[2]*(q)[2])
#define  NRM(p)           sqrt(DOT((p),(p)))
#define  DG            M_PI/180
#define  S(u)          sin(u*DG)
#define  C(u)          cos(u*DG)
#define  CLAMP(x,u,v) (x<u? u : (x>v ? v: x))

float lux[3]={1.,2.,3.};     /*light source direction vector        */
float luxx[3];     /* current light direction */
float mysiz,
speed, 
torq, 
focal, 
fclip;                          /*console navigation variables   */
int win = 2;                  /* full screen, use 0 for demand sized */
unsigned int BUT,XX,YY,SHIF;  /* used in chaptrack gluttery           */
int xt,yt;                    /* once was xt,yt,xm,ym for viewportery */
int msg,binoc;                /* for messageboard and binocular vision */ 
float nose;
#define FLYMODE  (0)
#define BLUEMODE (1)


/*Global variables*/

float ident[16]={1.,0.,0.,0., 0.,1.,0.,0., 0.,0.,1.,0.,0.,0.,0.,1.};

float 
siz,              /* virtual observer size   */
kappa,            /* */
lambda;           /* */

/* float geomat[16];   replaces  "aff" */

int
curv,              /* curvature, +1 spherical, -1 hyperbolic */
blackout,          /* cycle through the furniture in SPHERICAL */ 
more,              /* cycle through the levels in HYPERBOLIC */ 
mode;             /* flymode is the only one that makes sense */



/*%%%%%%%%%%%%%%%%%begin CAVEish 1 %%%%%%%%%%%%%%%%%%*/


//formerly caveyes, now called eyes.  indicates console, cave, or syzygy 
enum {console, cave, syzygy} eyes;  //I know it was cave, yes, not cav eyes


/*Shared memory variables as per Stuart Levy 1994 */
struct share_var{
   float  s_siz;         /*final scaling factor before projection      */
   int s_wnd;            /*wand or maus flag                           */
   int s_gnd;            /*background color                            */
   float s_luxx[3];         /* current light direction */
   int s_mauspaw ;      /*binary for mouse button state                     */
   int s_th0 ;           /* since the autotymer changes these          */
   int s_th1 ;           /* they need to be shared                      */
   int s_ta0 ;           /*                                             */
   int s_ta1 ;           /*                                             */
   float s_gap ;           /*                                             */
   GLfloat s_geomat[16],s_starmat[16]; /*affine matrices for object, stars*/
} *s_var;

#define siz     (s_var->s_siz)
#define wnd     (s_var->s_wnd)
#define gnd     (s_var->s_gnd)  /* use only if printframe function is present */
#define luxx      (s_var->s_luxx )
#define geomat     (s_var->s_geomat)
#define starmat (s_var->s_starmat)
#define mauspaw (s_var->s_mauspaw)
#define th0 (s_var->s_th0)
#define th1 (s_var->s_th1)
#define ta0 (s_var->s_ta0)
#define ta1 (s_var->s_ta1)
#define gap (s_var->s_gap)

/* these are used only in console mode      */
/***********************************************************************/
void getmem(void){
  if(eyes==cave)
#ifdef CAVE
     s_var = CAVEMalloc(sizeof(struct share_var))
#endif /* CAVE */
     ;
  else /* CONSOLE or SYZYGY*/
    s_var = (struct share_var *)malloc(sizeof(struct share_var));
  if(s_var==NULL){fprintf(stderr,"No room to share! %x \n",s_var); exit(1);}
}

#ifdef SYZYGY
bool szginit(arMasterSlaveFramework& fw, arSZGClient&){
  glEnable(GL_DEPTH_TEST);
  glDisable(GL_CULL_FACE);   /* what if we don't ? */ 

//this is how Syzygy does shared memory.
  fw.addTransferField("siz", (&siz), AR_FLOAT, 1);
  fw.addTransferField("wnd", (&wnd), AR_INT, 1);
  fw.addTransferField("gnd", (&gnd), AR_INT, 1);
  fw.addTransferField("luxx", luxx, AR_FLOAT, 3);
  fw.addTransferField("mauspaw", &mauspaw, AR_INT, 1);
  fw.addTransferField("th0", (&th0), AR_INT, 1);
  fw.addTransferField("th1", (&th1), AR_INT, 1);
  fw.addTransferField("ta0", (&ta0), AR_INT, 1);
  fw.addTransferField("ta1", (&ta1), AR_INT, 1);
  fw.addTransferField("gap", (&gap), AR_FLOAT, 1);
  fw.addTransferField("geomat", geomat, AR_FLOAT, 16);
  fw.addTransferField("starmat", starmat, AR_FLOAT, 16);
  fw.addTransferField("curv", &curv, AR_INT, 1);

  return true;
}
#endif

/*%%%%%%%%%%%%%%%%%end  CAVEish %%%%%%%%%%%%%%%%%%*/


/***************************liberated frustum*******************/

void jiehlFrustum( GLdouble wleft, GLdouble wright,
		GLdouble wbottom, GLdouble wtop,
		GLdouble wnclip, GLdouble wfclip )
{
  GLdouble T[16];
  GLdouble tn = 2*wnclip;
  GLdouble rl = wright - wleft;
  GLdouble tb = wtop - wbottom;
  GLdouble fn = wfclip - wnclip;

  T[0] = tn/rl;
  T[1] = 0;
  T[2] = 0;
  T[3] = 0;

  T[4] = 0;
  T[5] = tn/tb;
  T[6] = 0;
  T[7] = 0;

  T[8] = (wright+wleft) / rl;
  T[9] = (wtop+wbottom) / tb;
  T[10] = -(wfclip+wnclip) / fn;
  T[11] = -1;

  T[12] = 0;
  T[13] = 0;
  T[14] = -2*wfclip*wnclip / fn;
  T[15] = 0;

  glMultMatrixd( T );
}



/***************************liberated frustum*******************/



/*matrices for hyperbolic and spherical tiling*/
#include "927hyp.h"  /* HKAPPA 2.22 HN_TRANS 927 */ 
#include "120sph.h"  /* SKAPPA 1.01 SN_TRANS 120 */

/*how to draw a dodecahedron (object)*/
#include "dod.descrip.h" /* N_VERTS 20 N_FACES 12 */

void char2wall(GLfloat x,GLfloat y, GLfloat z, char buf[]){
     char *p; glRasterPos3f(x,y,z);
     for(p = buf;*p;p++) glutBitmapCharacter(GLUT_BITMAP_9_BY_15,*p);
}

deFault(){int ii,jj; float tmp;  
   msg=1; binoc=0; nose=.06; fclip = 1000;   
   mode=0; /* 0 for flying and 1 for command mode */
   speed=.01; torq=.02; focal = 2.; fclip =13.; mysiz=.01;
/* space-specific parameters */
   curv = -1; /* hyperbolic -1, +1 for elliptic */
   siz=SIZE; 
   more=(1<<LEVELS)-1;  
   kappa = (HYPERBOLIC?0.98:1.); blackout=(HYPERBOLIC?1:0); 
   lambda = .2*(kappa);
   FOR(ii,0,16)geomat[ii]=ident[ii];
   tmp=NRM(lux);  for(ii=0;ii<3;ii++)lux[ii]/=tmp;

/* %%%%%%%%%%%%%begin CAVE%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% */
   mauspaw = 0; wnd = 1;   /* CAVE initials */
}

void dataprep(void){
     /* audioprep(); */
      deFault();
}
/*%%%%%%%%%%%%%%%%%end  CAVEish %%%%%%%%%%%%%%%%%%*/

/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
drawdodo(float scalar, int render, float trafo[4][4])
{  /* draw|render([ddv] <- scalar [ddvert][trafo]) */ 

  int ii,jj,kk; 
  float ddvtmp[N_VERTS][4],ddv[N_VERTS][4];

 FOR(ii,0,N_VERTS){
  FOR (jj,0,3) ddvtmp[ii][jj] = scalar * ddvert[ii][jj];
  if (SPHERICAL)
    ddvtmp[ii][3] = 1/sqrt(1 + EDOT(ddvert[ii],ddvert[ii]));  
  else /* HYPERBOLIC */
    ddvtmp[ii][3] = 1.;
  FOR (jj,0,4)
    {
    ddv[ii][jj] = 0.;
    FOR (kk,0,4)
      ddv[ii][jj] += ddvtmp[ii][kk]*trafo[kk][jj];
    }
  }

 if (render)
  {
  FOR (ii,0,N_FACES)
    {
     glBegin(GL_POLYGON);
     if (HYPERBOLIC) glColor3fv(hddcolr[ii]); else glColor3fv(sddcolr[ii]);
     FOR (jj,0,FACE_VERTS) glVertex4fv(ddv[ddface[ii][jj]]); 
     glEnd();
    }
  }
else
  {
  glBegin(GL_LINE_STRIP);
  for(ii=0;ddwire[ii]!=-2;ii++)
    if (ddwire[ii]==-1)
      {
       glEnd();
       glBegin(GL_LINE_STRIP);
      }
    else  glVertex4fv(ddv[ddwire[ii]]);
    glEnd();
  }
} /* end drawdodo */


hdrawtess()   /*** actually draws the whole thing ***/
{   /*special case procedure for coloring/drawing based on distance,
     sdrawtess is more generic */
   float divisions[LEVELS+1] = { 999.9, 20.0, 14.0, 6.0, 1.0, 0.0};
   float divcols[LEVELS][3] = {{.12,.37,.12},/*  1=more for greeen  */
                               {.37,.12,.37},/*  2=more for magenta */
                               {.5,.5,.12},  /*  4=more for cyan    */
                               {0,1,1},      /*  8=more for yellow  */
                               {1,1,1}};     /* 16=more for white   */
   static float dists[HN_TRANS];
   int ii,lvl;
   static int first=1;       /* for objects */
   static int hyptessobj[LEVELS];    /* for objects */

    if (first)
    {
       first = 0;
       FOR(lvl,0,LEVELS) hyptessobj[lvl] = glGenLists(1);
       FOR(ii,0,HN_TRANS) dists[ii] = ENORM(hgrp[ii][3]);
       FOR(lvl,0,LEVELS)
       {
           glNewList(hyptessobj[lvl],GL_COMPILE);
           FOR(ii,0,HN_TRANS)
           {
              if((dists[ii]<divisions[lvl])&&(dists[ii]>=divisions[lvl+1]))
              {
                  glColor3fv(divcols[lvl]); 
                  drawdodo((kappa)*HKAPPA,0,hgrp[ii]);
              }
           }
           glEndList();
       }
    }

    FOR(lvl,0,LEVELS)  if(more & (1<<lvl)) glCallList(hyptessobj[lvl]);
}

sdrawtess()   
{  int ii,ll;
   static int frameobj,lildodobj;
   static int first=1;
   if(first){ first = 0;
     lildodobj=glGenLists(1);
     frameobj =glGenLists(1);
     glNewList(frameobj, GL_COMPILE);
     FOR(ii,0,SN_TRANS)
       drawdodo((lambda)*SKAPPA,1,sgrp[ii]);
     glEndList();
     glNewList(lildodobj, GL_COMPILE);
     glColor3f(0,1,1);
     FOR(ii,0,SN_TRANS)
       drawdodo((kappa)*SKAPPA,0,sgrp[ii]);
     glEndList();
   } 
   if(!((blackout) & 1)) glCallList(lildodobj);
   if(!((blackout) & 2)) glCallList(frameobj);
}

drawtess(){if(HYPERBOLIC)hdrawtess();else sdrawtess();} 

static Translate(int dir, float spd )
{
  float mat[16] = {1.,0.,0.,0., 0.,1.,0.,0., 0.,0.,1.,0.,0.,0.,0.,1.};
  int ii;
  if(HYPERBOLIC)
     {
     mat[dir*4+dir]=mat[3*4+3]= cosh(spd);
     mat[dir*4+3]=mat[3*4+dir]= sinh(spd);
     }
  else  /*spherical (elliptical) translate*/
     {
     mat[dir*4+dir]=mat[3*4+3]= cos(spd);
     mat[dir*4+3]=-sin(spd); mat[3*4+dir]= sin(spd);
     }
  glMultMatrixf(mat);
}

/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */


void arguments(int argc,char **argv){
eyes=syzygy;  //for now
#ifdef UNIX
  extern char *optarg;
  extern int optind; 
  int chi;   
  /* w: needs ONE number after -w, c<nothing> means NO number follows*/ 
  while ((chi = getopt(argc,argv,"w:cd:g:")) != -1) 
  switch(chi)  {
                case 'c': eyes = cave ; break; 
                case 'w': win=atoi(optarg); break; 
                }
  if (optind!=argc) fprintf(stderr,"%s: Incorrect usage\n",argv[0]);
#endif
}

void keyboard(unsigned char key, int x, int y){
#define  IF(K)            if(key==K)
#define  PRESS(K,A,b)     IF(K){b;}IF((K-32)){A;}  
/*was backwards in previous versions */
#define  TOGGLE(K,flg)    IF(K){(flg) = 1-(flg); }
#define  CYCLE(K,f,m)     PRESS((K), (f)=(((f)+(m)-1)%(m)),(f)=(++(f)%(m)))
#define  SLIDI(K,f,m,M)   PRESS(K,(--f<m?m:f), (++f>M?M:f))
#define  SLIDF(K,f,m,M,d) PRESS(K,((f -= d)<m?m:f), ((f += d)>M?M:f))
/* Only ASCII characters can be processes by this GLUT callback function */ 
   TOGGLE('v',binoc);                            /* cross-eyed STEREO   */
   TOGGLE('w',msg);                              /* writing on/off      */
   TOGGLE('c',curv);                             /* curvature    */
   IF('m') { if(HYPERBOLIC)more = (++(more)%(1<<LEVELS)); 
             else blackout =(++(blackout)%3);}
   PRESS('n', nose -= .001 , nose += .001 );     /* for binoculars      */
   CYCLE(' ', mode,BLUEMODE+1);                  /* fly/turn modes      */
   PRESS('i', mysiz /= 1.1, mysiz *= 1.1)        /* rescale the world   */
   PRESS('o', focal *= 1.1 , focal /= 1.1)       /* telephoto           */
   PRESS('p', fclip /= 1.01 , fclip   *= 1.01)       /* rear clipping plane */
   PRESS('a', siz *= 1.01 , siz   /= 1.01)       /* model scaling       */
   PRESS('s',speed /= 1.02, speed *= 1.02);      /* flying speed        */
   PRESS('q',torq /= 1.02, torq *= 1.02);        /* turning speed       */
   PRESS('z', deFault(), deFault());             /* zap changes         */
   IF(27) { exit(0); }              /* ESC exit            */
}

void special_keybo(int key, int x, int y){
/*non-ASCII keypresses go here, if you're lucky enough to know their names */
 fprintf(stderr," non-ASCII character was pressed.\n");
 fprintf(stderr," use special_keybo() to process it\n");

switch(key) {

#if 0 
  case GLUT_KEY_RIGHT:     edx = getnumber(1); tymer(); break;
  case GLUT_KEY_LEFT:      step = -getnumber(1); tymer(); break;
  case GLUT_KEY_UP:        bump(&movierate, .1); break;
  case GLUT_KEY_DOWN:      bump(&movierate, -.1); break;


 /*Stuart's version  */
  case GLUT_KEY_HOME:      setpark( 1 ); break;
  case GLUT_KEY_END:       setpark( 0 ); break;
  case GLUT_KEY_PAGE_DOWN: snap = getnumber(9999); snapno = -1; break;
  case GLUT_KEY_PAGE_UP:   if(snap>0) {snap = 0, snapno = -1;} else snap = 1;
                           break;
  case GLUT_KEY_RIGHT:     step = getnumber(1); tymer(); break;
  case GLUT_KEY_LEFT:      step = -getnumber(1); tymer(); break;
  case GLUT_KEY_UP:        bump(&movierate, .1); break;
  case GLUT_KEY_DOWN:      bump(&movierate, -.1); break;
  case GLUT_KEY_F1:        tymode = getnumber(!tymode); break;
  case GLUT_KEY_F2:        zoom2 = getnumber(!zoom2); break;
  case GLUT_KEY_F3:        if(playfname) playon(playfname); break;
  case GLUT_KEY_F4:        if(tracefname) {
                                tracelimit = getnumber(1<<30);
                                traceon(tracefname);
#endif 
                           }
} /* end of special_keybo */

float speedometer(void){
#ifdef UNIX
double dbl; static double rate; static int ii=0;
static struct timezone notused; static struct timeval now, then;
   if(++ii % 8 == 0){  /* 8 times around measure time */
      gettimeofday(&now, &notused); /* elapsed time */
      dbl =  (double)(now.tv_sec - then.tv_sec)
         +(double)(now.tv_usec - then.tv_usec)/1000000;
      then = now;  rate = 8/dbl;
      }
   return((float)rate);
#endif
  return 0;
}

void reshaped(int xx, int yy){xt=xx ; yt=yy;}   /* gluttery */
 
void messages(void){     
  char buf[256]; /* console messages are done differently from cave */
#define  LABEL2(x,y,W,u) {sprintf(buf,(W),(u));char2wall(x,y,0.,buf);}
  glMatrixMode(GL_PROJECTION); glPushMatrix(); glLoadIdentity();
  gluOrtho2D(0,3000,0,3000);
  glMatrixMode(GL_MODELVIEW); glPushMatrix(); glLoadIdentity();
      /*bull's eye*/
      if(mode==0) glColor3f(0x22/255.,0x88/255.,0xdd/255.);
        else      glColor3f(.8,.8,.8);
      LABEL2(1500,1500,"%s","o");
      /* writings */
      if(mode==0) glColor3f(1.,0.,1.);
        else      glColor3f(1.,1.,0.);
      LABEL2(80,80,"%4.1f fps",speedometer());
      LABEL2(80,2840,\
      "(ESC)ape (V)Binoc (MAUS2)Fore (BAR)Flymode %s (H)omotopy (W)riting",
             mode?"FLYING":"CONTROL");
      LABEL2(10,10,"illiOpenSkelGLUT \
   by Francis, Bourd, Hartman & Chappell, U Illinois, 1995..1997 %s","");
      LABEL2(80,2770,"(N)ose   %0.3f",nose);
      LABEL2(80,2700,"(S)peed  %0.4f",speed);
      LABEL2(80,2630," tor(Q) %0.4f",torq);
      LABEL2(80,2560,"nclip clipper %g", mysiz*focal);
      LABEL2(80,2490,"f(O)cal factor %g",focal);
      LABEL2(80,2420,"my s(I)ze %.2g",mysiz);
      LABEL2(80,2350,"fclip cli(P)er= %.2g",-curv*fclip);
      LABEL2(80,2280,"sc(A)le siz %.2g",siz);
      LABEL2(80,2210,"(Z)ap %s","");
    glPopMatrix();
glMatrixMode(GL_PROJECTION); glPopMatrix();
} 

void chaptrack(int but,int xx,int yy,int shif){  
   /* needs torq, speed */
   long dx,dy; 
   dx = xx -.5*xt; dx = abs(dx)>5?dx:0;
   dy = yy -.5*yt; dy = abs(dy)>5?dy:0;

   glMatrixMode(GL_MODELVIEW); glPushMatrix(); 

   glLoadIdentity();
   glRotatef(dx*torq,0.,1.,0.); glRotatef(dy*torq,1.,0.,0.);
   if(but&(1<<GLUT_RIGHT_BUTTON ))glRotatef(shif?-10:-1,0.,0.,1.);
   if(but&(1<<GLUT_LEFT_BUTTON  ))glRotatef(shif? 10:1,0.,0.,1.);

   if(but&(1<<GLUT_MIDDLE_BUTTON)) Translate(2,shif ? -speed : speed);
   glMultMatrixf(geomat); 
   glGetFloatv(GL_MODELVIEW_MATRIX,geomat);
   {int ii,jj; for(ii=0;ii<3;ii++){ luxx[ii]=0; /* calculite */
          for(jj=0;jj<3;jj++) luxx[ii] += geomat[ii*4+jj]*lux[jj];}}
   glPopMatrix();
}


void drawcons(void){  
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  if(binoc) glViewport(0,yt/4,xt/2,yt/2);
  glMatrixMode(GL_PROJECTION); glLoadIdentity();
  jiehlFrustum(-mysiz*xt/yt,mysiz*xt/yt,-mysiz,mysiz,mysiz*focal, (HYPERBOLIC ? fclip : -mysiz) ); 
  glMatrixMode(GL_MODELVIEW); glLoadIdentity();
  /* drawstars();  */
  glTranslatef(-binoc*nose,0.0,0.0);

  glMultMatrixf(geomat);
  glScalef(siz,siz,siz);
  drawtess(); 
  if(binoc){
    glViewport(xt/2,yt/4,xt/2,yt/2); 
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
    /* drawstars(); */
    glTranslatef(binoc*nose,0.0,0.0);
    glMultMatrixf(geomat);
  drawtess();
    }
  glViewport(0,0,xt,yt);
  if(msg) messages();
  glutSwapBuffers();
}

void drawsyzygy()
{
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  glMatrixMode(GL_PROJECTION); glLoadIdentity();
float ff=0.01;
  jiehlFrustum(-ff,ff,-ff,ff,0.02, (HYPERBOLIC)?13:-0.01 ); 

  glMatrixMode(GL_MODELVIEW); 
  glLoadIdentity();
  glScalef(10,10,10);
  glMultMatrixf(geomat);
  drawtess();

}

/* %%%%%%%%%%%%%%%%%%%%%%%%%%GLUTTERY%%%%%%%%%%%%%%%%%%%%%%%%%%%%% */ 


void idle(void){ /*do this when nothing else is happening*/
   glutPostRedisplay();  /*redraw the window*/
   chaptrack(BUT,XX,YY,SHIF);
}

void mousepushed(int but,int stat,int x,int y){
  if(stat==GLUT_DOWN) BUT |= (1<<but);
  else BUT &= (-1 ^ (1<<but));  
  XX=x; YY=y; SHIF=(glutGetModifiers()==GLUT_ACTIVE_SHIFT)?1:0;
}

void mousemoved(int x,int y){  XX=x; YY=y; }


/* where old main used to be */
#ifdef CAVE /* %%%%begin CAVE%%%%%%%%%%%%%%%%%%%%% */
void cavekeybo(void){
#define  CAVEIF(K)         if(CAVEgetbutton(K))
#define  CAVEPRESS(K,A,b)  CAVEIF(K){if(CAVEgetbutton(CAVE_LEFTSHIFTKEY)||\
                           CAVEgetbutton(CAVE_RIGHTSHIFTKEY)){b;}else{A;}}
#define  CAVETOGGLE(K,flg) CAVEIF(K){(flg) = 1-(flg); }
#define  CAVECYCLE(K,f,m)  CAVEPRESS((K),(f)=(((f)+(m)-1)%(m)),(f)=(++(f)%(m)) )
#define  CAVESLIDI(K,f,m,M)  CAVEPRESS(K,(--f<m?m:f), (++f>M?M:f))
#define  CAVESLIDF(K,f,m,M,d) CAVEPRESS(K,((f -= d)<m?m:f), ((f += d)>M?M:f))  

 CAVEPRESS(CAVE_QKEY, speed /= 1.02, speed *= 1.02);/* flying speed       */  
 CAVEPRESS(CAVE_RKEY, torq /= 1.02,  torq *= 1.02); /* turning speed      */  
 CAVETOGGLE(CAVE_YKEY,wnd);              /* mauspaw vs wandpaw *//* not yet implemented */
 CAVEPRESS(CAVE_ZKEY, deFault(), deFault());        /* zap changes       */
}

void graffiti(void){             /* used to be called speedo  */
  char buf[256];                 /*messages written into here */
#define  LABEL3(x,y,z,W,u){sprintf(buf,(W),(u));char2wall(x,y,z,buf);}
  static float last=0.,fps;      /*for measuring time         */
  if(!CAVEMasterDisplay()) return;  /* USE CAVEMasterWall in papeBeta */
                                    /* in grafiXlab we have old CAVElib? */
  if(floor(2.*(*CAVETime))>floor(2.*last)){  /* rationalize this */
     last=*CAVETime;
     fps=*CAVEFramesPerSecond;
     }
  if(mode==BLUEMODE){
        glColor3f(1.,0.,1.);
        LABEL3(-3.8,1.,-5.0,\
          "4=auto 2=mode 3=shrink 6=grow 5=freeze 7=reset %s","");
        } else {
        glColor3f(1.,1.,0.);
        LABEL3(-3.8,1.0,-5.0,
          " push thumb-button to fly, 2=tractor gap %s","gap");
        }
     LABEL3(-4.8,8.0,-5.0, "illiOpenSkelGLUT\
    by Francis, Bourd, Hartman & Chappell, (C) 1995..1997 U.Illinois %s","")
       LABEL3(-4.8,1.0,-5.0,"%5.1f fps",fps);
}

void cavetrack(void){
  float torq = .006;
  float azi,ele,rol,hx,hy,hz,wx,wy,wz;
  static float ohx,ohy,ohz;   /*old head position */
  static float owx,owy,owz;   /*old wand position */
  static int opaw = 0,paw, joy = 0, friz;

  if(!CAVEMasterDisplay()) return;  /* doit once per frame */
  paw = wnd ? (CAVEBUTTON1*2+CAVEBUTTON2)*2+CAVEBUTTON3 : mauspaw;
  if(paw) joy = 1; /* activate joystick by clicking any button*/
  if(opaw!=2 && paw==2) mode = (mode+1)%(BLUEMODE+1); /* click modes */
  if(mode==BLUEMODE){   /* hold middle button and click right to shrink */
     if (opaw == 2 && paw == 3)siz /= 1.5;     /*shrink object */
     if (opaw == 2 && paw == 6)siz *= 1.5;     /* grow   object */
     if (opaw != 4 && paw == 4)
          if(HYPERBOLIC)more = (++(more)%(1<<LEVELS));
          /*spherical*/ else blackout =(++(blackout)%3);
     if (opaw != 5 && paw == 5)curv = -curv ;
     }

  if(opaw==2 && paw == 7){ /* restart, the most useful feature */
     deFault(); ohx=ohy=ohz=0; owx=owy=owz=0;
     }
  if(wnd){
      CAVEGetWandOrientation(azi,ele,rol);
      CAVEGetHead(hx,hy,hz);  /*position*/
      CAVEGetWand(wx,wy,wz);  /*position*/
      }
   else{  /* fix this for CAVE mouse flying */
      azi = .5*512; ele = .5*-512;
      }
   glMatrixMode(GL_MODELVIEW); glPushMatrix(); glLoadIdentity();

   Translate(0,(ohx-hx)/5); Translate(1,(ohy-hy)/5); Translate(2,(ohz-hz)/5);

   if(!friz){  /* if not parked */
      glRotatef(rol*(mode?torq:-torq),0.,0.,1.);
      glRotatef(ele*-torq, 1.,0.,0.);
      glRotatef(azi*-torq,0.,1.,0.);
      }

   if(joy&&((fabsf(CAVE_JOYSTICK_Y)>.02)||(fabsf(CAVE_JOYSTICK_X)>.02)))
     /* glTranslatef(CAVE_JOYSTICK_X*speed,0.,CAVE_JOYSTICK_Y*speed); */
      {
       Translate(0,CAVE_JOYSTICK_X*speed);
       Translate(2,CAVE_JOYSTICK_Y*speed);
      }

    glMultMatrixf(geomat);
    glGetFloatv(GL_MODELVIEW_MATRIX,geomat);

   {int ii,jj; for(ii=0;ii<3;ii++){ luxx[ii]=0; /* calculite */
   for(jj=0;jj<3;jj++) luxx[ii] += geomat[ii*4+jj]*lux[jj];} }

   glPopMatrix();
   opaw=paw; ohx=hx; ohy=hy; ohz=hz;
             owx=wx; owy=wy; owz=wz;
/* audiofunc(); */
}

void caveinit(void){   /* kludge? needed why ? */
   glClearColor(0.,0.,0.,0.);
   glClearDepth(1.);
   deFault();
}

void printcurrmat(void){
   float mat[16];
   glGetFloatv(GL_MODELVIEW_MATRIX,mat);
   printf("\n");
   printf(" %2.4f  %2.4f %2.4f %2.4f \n", mat[0], mat[4], mat[8], mat[12]);
   printf(" %2.4f  %2.4f %2.4f %2.4f \n", mat[1], mat[5], mat[9], mat[13]);
   printf(" %2.4f  %2.4f %2.4f %2.4f \n", mat[2], mat[6], mat[10], mat[14]);
   printf(" %2.4f  %2.4f %2.4f %2.4f \n", mat[3], mat[7], mat[11], mat[15]);
   printf("\n");
}




void drawcave(void){
  float hx,hy,hz;
  CAVENear = .01; 
/* the default appears to be .1 in libcave_ogl.a */
/* backface(true) backface removal true was in the 1996 code */
/* glFrontFace(GL_CCW) counterclockwise .... */
/*  glCullFace(GL_BACK); */
/*  printf("CAVENear = %2.4f \n ", CAVENear); */
  CAVEFar = (HYPERBOLIC ? 1000: -1*CAVENear);   /* 1996 original issue was -.1 */
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  graffiti();
  CAVEGetHead(hx,hy,hz);
  glTranslatef(hx,hy,hz);
  glScalef(siz,siz,siz);   /* yep ... this was here in 1996! */
  glMultMatrixf(geomat);   /* remember, we deform the model */
/* printcurrmat(); */
  drawtess();           /* drawall here error cost a lot */ 
}
#endif  /*%%%%%%%%%%%%end CAVE %%%%%%%%%%%%%%*/

#ifdef SYZYGY
void szgPreExchange(arMasterSlaveFramework& fw){
  if (!fw.getMaster())
    return;

  //below is partly ripped from CAVEtrack, partly from Schaffer's hspace,
  //and partly original
  //we want to calculate geomat and luxx and starmat so that they
  //can be shared
   glMatrixMode(GL_MODELVIEW); glPushMatrix(); glLoadIdentity();
   const float j0 = fw.getAxis(0);
   const float j1 = fw.getAxis(1);
   Translate(2,j1/100.0);
   glRotatef(j0/6.0, 0.,1.,0.);

    glMultMatrixf(geomat);
    glGetFloatv(GL_MODELVIEW_MATRIX,geomat);

   {int ii,jj; for(ii=0;ii<3;ii++){ luxx[ii]=0; /* calculite */
   for(jj=0;jj<3;jj++) luxx[ii] += geomat[ii*4+jj]*lux[jj];} }

   glPopMatrix();

  const int button[3]={fw.getButton(0), fw.getButton(1), fw.getButton(2)};
  if(button[0] == 1)
  {
    curv=-curv;
    for(int ii=0; ii<16; ii++)geomat[ii]=ident[ii];
  }
}

bool szgPostExchange(arMasterSlaveFramework&)
{
  //now we want to do any calculations that would rely on the shared stuff
  
  return true;
}


void szgDrawCallback(arMasterSlaveFramework& fw)
{
  if(fw.getConnected()){
    drawsyzygy();
  }
}


#endif


/*%%%%%%%%%%%%%%%common MAIN %%%%%%%%%%%%%%%%%%*/
int main(int argc, char **argv){
   arguments(argc,argv);
   if(eyes == cave)
#ifdef CAVE
   CAVEConfigure(&argc, argv, NULL)
#endif
   ;  /* don't miss that semi-colon */
   getmem();  /* getmem respects eyes */
   dataprep();

   if(eyes == cave){
#ifdef CAVE
       CAVEInit(); /* Each wall is (part of) a forked process from here on.*/
       CAVEFrameFunction(cavetrack,0); /*is restricted to MasterWall, so once per frame */
       CAVEInitApplication(caveinit, 0);
       CAVEDisplay(drawcave, 0);
       while(!CAVEgetbutton(CAVE_ESCKEY)) /*cavekeybo() */ ;    /* kludge ... we don't need any */
   /*  audioclean(); */
       CAVEExit();
#endif
       ;}
     else if(eyes==console){ /*console main, not caveyes */
       glutInit(&argc, argv);
       glutInitDisplayMode(GLUT_DOUBLE|GLUT_DEPTH);
       switch(win)
         { case 0: break;
           case 1: glutInitWindowSize(640, 480);
                   glutInitWindowPosition(0,1024-480);
                   break;
           case 2: glutInitWindowPosition(0,0);
                   break;
         }
       glutCreateWindow("<* illiSkel in C/OpenGL/GLUT *>");
       if(win==2) glutFullScreen();
       glEnable(GL_DEPTH_TEST);
       glDisable(GL_CULL_FACE);   /* what if we don't ? */ 
       glutDisplayFunc(drawcons);   
       glutKeyboardFunc(keyboard);
       glutSpecialFunc(special_keybo);
       glutMouseFunc(mousepushed);
       glutMotionFunc(mousemoved);
       glutPassiveMotionFunc(mousemoved);
       glutReshapeFunc(reshaped);
       glutIdleFunc(idle);
       glutMainLoop();
       }
     else if(eyes==syzygy){ //syzygy main
       arMasterSlaveFramework framework;
       if(!framework.init(argc,argv))
         return 1;
       framework.setInitCallback(szginit);
       framework.setPreExchangeCallback(szgPreExchange);
       framework.setDrawCallback(szgDrawCallback);
       framework.setPostExchangeCallback(szgPostExchange);
       framework.setClipPlanes( .1, 1000 );
       framework.setEyeSpacing(6/(12*2.54));
       return framework.start() ? 0 : 1;
     }

}

